<template>
    <div class="field-tags">
        <input
            ref="input"
            :placeholder="placeholder"
            type="text"
            class="input main field-tags__input"
            v-model.trim="text"
            @keyup.enter="addTag"
            @keyup="getDaData"
            @blur="() => this.visibleDaData = false"
            @focus="() => this.visibleDaData = true"
        >
        <div
            v-if="daData"
            class="field-tags__data-wrap"
        >
            <div
                v-if="daDataList && visibleDaData && text.length >= 3"
                class="field-tags__data-list"
            >
                <div
                    v-if="daDataList.length"
                    @mousedown.stop="addDaDataTag"
                >
                    <div
                        v-for="({ name, id }) in daDataList"
                        :key="id"
                        class="field-tags__data-item"
                    >
                        {{ name }}
                    </div>
                </div>
                <div v-else>
                    <div class="field-tags__data-item field-tags__data-item--disable">Ничего не найдено</div>
                </div>
            </div>
        </div>
        <div class="field-tags__tag-list">
            <div
                v-for="(tag, key) in tags"
                :key="key"
                class="field-tags__tag-item"
            >
                <div
                    v-if="daData"
                    class="field-tags__tag-text"
                >{
                    { tag.name }}
                </div>
                <div
                    v-else
                    class="field-tags__tag-text"
                >
                    {{ tag }}
                </div>
                <div
                    class="field-tags__tag-delete"
                    @click="deleteTag(key)"
                />
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'base-field-tags',
    props: {
        value: {
            type: Array,
            required: true
        },
        placeholder: {
            type: String,
            default: ''
        },
        daData: {
            type: String,
            required: false
        }
    },
    data() {
        return {
            text: '',
            tags: [],
            daDataList: null,
            visibleDaData: false
        };
    },
    watch: {
        value(val) {
            if (!val.length) {
                this.text = '';
                this.tags = [];
            }
        }
    },
    created() {
        this.tags = this.value.slice();
    },
    methods: {
        addTag() {
            if (this.text && !this.daData) {
                this.tags.push(this.text);
                this.text = '';
                this.$emit('input', this.tags);
            }
        },
        getDaData() {
            if (this.daData) {
                if (this.text.length >= 3) {
                    axios.get(this.daData, {
                        params: {
                            query: this.text
                        }
                    })
                        .then(response => {
                            const { data } = response.data;
                            if (data) this.daDataList = data;
                        })
                        .catch(error => {
                            console.error(error);
                        });
                } else {
                    if (this.daDataList) this.daDataList = null;
                }
            }
        },
        addDaDataTag(e) {
            const value = e.target.innerText;
            const daDataItem = this.daDataList.find(item => item.name === value);

            if (!this.tags.length || this.tags.some(({ id }) => id !== daDataItem.id)) {
                this.tags.push(Object.assign({}, daDataItem));
                this.$emit('input', this.tags);
            }
            this.daDataList = null;
            this.text = '';
        },
        deleteTag(key) {
            this.tags.splice(key, 1);
            this.$emit('input', this.tags);
        }
    }
};
</script>

<style lang="sass">
@import "~assets/blocks/fields/field-tags/index"
</style>
